Não pode escolher mais do que 25 tópicos Os tópicos devem começar com uma letra ou um número, podem incluir traços ('-') e podem ter até 35 caracteres.
 
 
 
 
 
 

1406 linhas
33 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. #################################
  21. # profile-like setups
  22. __safe_add_path_r(){
  23. # add path to right
  24. test -d "$1" && PATH="${PATH}:$1"
  25. }
  26. __safe_add_path_l(){
  27. # add path to left
  28. test -d "$1" && PATH="$1:${PATH}"
  29. }
  30. __safe_add_path_l "$HOME/.cabal/bin"
  31. __safe_add_path_l "$HOME/.local/lib/gems/bin"
  32. __safe_add_path_l "$HOME/.local/bin"
  33. __safe_add_path_l "$HOME/.gem/ruby/2.1.0/bin"
  34. __safe_add_path_r "/c/mingw/bin"
  35. __safe_add_path_r "/c/mingw/msys/1.0/bin"
  36. # macports coreutils
  37. # $isdarwin cannot be used it is not defined yet
  38. __safe_add_path_l "/opt/local/bin"
  39. __safe_add_path_l "/opt/local/sbin"
  40. __safe_add_path_l "/opt/local/libexec/gnubin"
  41. __safe_add_path_l \
  42. "/opt/local/Library/Frameworks/Python.framework/Versions/3.2/bin"
  43. test -f "${__dotdir}/rc.py" && export PYTHONSTARTUP="${__dotdir}/rc.py"
  44. test -d "$HOME/.local/lib/python/site-packages" && \
  45. export PYTHONPATH="${PYTHONPATH}:${HOME}/.local/lib/python/site-packages"
  46. export GEM_HOME="$HOME/.local/lib/gems"
  47. export RUBYLIB="$RUBYLIB:$HOME/.local/lib/gems/lib"
  48. # it is not so good
  49. # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  50. # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  51. # without this ENV i cannot run tmux. another way is to use --disable-shared
  52. # when building tmux
  53. if ! __match "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  54. then
  55. export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  56. fi
  57. # in my environment powerdown does not work
  58. test -z "$DISPLAY" && test -z "$SSH_CONNECTION" && \
  59. type setterm >/dev/null 2>&1 && \
  60. setterm -blank 30 -powersave on # -powerdown 10
  61. #########################
  62. # shrc.common
  63. # this variable must consistent with setup.sh
  64. __shrc_common="$HOME/.shrc.common"
  65. if test -f "$__shrc_common"
  66. then
  67. . "$__shrc_common"
  68. else
  69. echo "$__shrc_common not found."
  70. echo "Run setup.sh first."
  71. return
  72. fi
  73. ##########################
  74. # system type
  75. gnu_coreutils=false # for mac
  76. null ls --version && gnu_coreutils=true
  77. inbash=false
  78. inzsh=false
  79. if test -n "$BASH_VERSION"
  80. then
  81. inbash=true
  82. elif test -n "$ZSH_VERSION"
  83. then
  84. inzsh=true
  85. fi
  86. #################################
  87. # file pathes:
  88. # shrc: Path to this file
  89. if $inbash
  90. then
  91. __shrc="$BASH_SOURCE"
  92. elif $inzsh
  93. then
  94. __shrc="$0"
  95. fi
  96. ##################################
  97. # EnvVal definitions
  98. test "$TERM" = linux && export LANG=C
  99. export LC_MESSAGES=C
  100. export LC_TIME=C
  101. export TERMCAP="${TERMCAP}:vb="
  102. $ismsys && export HOSTNAME
  103. # export ENV=~/.shrc
  104. if false $iswindows
  105. then
  106. export PAGER='tr -d \\r | less'
  107. else
  108. export PAGER="less"
  109. fi
  110. export LESS="-iRMX"
  111. # Style for lesspipe is defined in esc.style
  112. _src_hilite_lp_path="`command -v src-hilite-lesspipe.sh 2>/dev/null`"
  113. for f in /usr/share/source-highlight/src-hilite-lesspipe.sh
  114. do
  115. test -z "$_src_hilite_lp_path" && test -e "$f" && _src_hilite_lp_path="$f"
  116. done
  117. test -n "$_src_hilite_lp_path" && export LESSOPEN="| $_src_hilite_lp_path %s"
  118. if null type vim
  119. then
  120. export EDITOR=vim
  121. else
  122. export EDITOR=vi
  123. fi
  124. # export CDPATH=".:~"
  125. export VISUAL="$EDITOR"
  126. export GIT_PAGER="less -F"
  127. export GIT_EDITOR="$EDITOR"
  128. export GIT_MERGE_AUTOEDIT=no
  129. if test -n "$TMUX" && \
  130. __match $TERM screen && \
  131. __match `tmux display -p '#{client_termname}'` 256color
  132. then
  133. TERM=screen-256color
  134. fi
  135. # set TMP, TEMP, TMPDIR
  136. if test -z "$TMP"
  137. then
  138. if test -n "$TMPDIR"
  139. then
  140. export TMP=$TMPDIR
  141. elif test -n "$TEMP"
  142. then
  143. export TMP="$TEMP"
  144. else
  145. export TMP=/tmp
  146. fi
  147. fi
  148. __match "$TMP" "${USER}-tmp" >/dev/null || TMP="${TMP}/${USER}-tmp"
  149. test -d "$TMP" || mkdir -p "$TMP"
  150. export TEMP=$TMP
  151. export TMPDIR=$TMP
  152. if ! $iswindows && null type stty
  153. then
  154. stty stop undef # unbind C-s to stop displaying output
  155. # stty erase '^h'
  156. fi
  157. if $iswindows
  158. then
  159. export USER=$USERNAME
  160. fi
  161. if test -d ~/dbx
  162. then
  163. export CHIT_PATH="$HOME/dbx/.chit"
  164. fi
  165. # adhoc fix for ansible on cygwin
  166. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  167. if $incygwin
  168. then
  169. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  170. fi
  171. ##########################
  172. # Zsh specific preferences
  173. # http://www.clear-code.com/blog/2011/9/5.html
  174. if $inzsh
  175. then
  176. bindkey -e
  177. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  178. autoload compinit; compinit
  179. # supress cycle by tab
  180. unsetopt auto_menu
  181. # unsetopt correct
  182. setopt complete_aliases
  183. setopt auto_list
  184. setopt bash_auto_list
  185. setopt magic_equal_subst
  186. setopt list_types
  187. # what is the difference of these two?
  188. setopt auto_param_slash
  189. setopt mark_dirs
  190. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  191. zstyle ':completion:*' format '%B%d%b'
  192. zstyle ':completion:*' group-name ''
  193. zstyle ':completion:*' use-cache yes
  194. # zstyle ':completion:*:cd:*' tag-order local-directories
  195. zstyle ':completion:*' completer _complete _bash_completions \
  196. _history
  197. # zstyle ':completion:*:*:cd:*' completer
  198. zstyle ':completion:*' accept-exact-dirs true
  199. zstyle ':completion:*' special-dirs true
  200. autoload colors; colors
  201. # autoload -Uz promptinit
  202. # promptinit
  203. # prompt walters
  204. setopt hist_ignore_dups
  205. setopt hist_ignore_all_dups
  206. setopt hist_save_no_dups
  207. setopt extended_history
  208. setopt share_history
  209. setopt append_history
  210. HISTFILE=$HOME/.zsh-history
  211. HISTSIZE=100000
  212. SAVEHIST=100000
  213. setopt prompt_subst
  214. setopt interactive_comments
  215. fi
  216. ######################
  217. # Print welcome messages
  218. command -v fortune >/dev/null && {
  219. if command -v cowsay >/dev/null
  220. then
  221. fortune | cowsay
  222. echo
  223. fortune -o | cowsay
  224. echo
  225. else
  226. fortune
  227. echo
  228. fortune -o
  229. echo
  230. fi
  231. }
  232. uname -a
  233. $iswindows && alias tty="echo cmd.exe"
  234. echo TERM $TERM with $(tput colors) colors using $(tty)
  235. echo
  236. __safe_run w yuk
  237. # if null type tmux
  238. # then
  239. # echo
  240. # echo tmux sessions:
  241. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  242. # echo
  243. # fi
  244. # if test -n "$TMUX"
  245. # then
  246. # tmux display -p \
  247. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  248. # 2>/dev/null
  249. # echo
  250. # fi
  251. ###################################
  252. # some aliases and functions
  253. # __func_name: never used interactively
  254. # _func_name: usually not used interactively
  255. __safe_alias(){
  256. # __safe_alias <name>=<command>
  257. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  258. test -n "$_bin" && \
  259. null type $_bin && \
  260. alias "$1"
  261. }
  262. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  263. # color prefs
  264. if $gnu_coreutils
  265. then
  266. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  267. # gnu coreutils LS_COLORS is used
  268. null type dircolors && eval `dircolors`
  269. _coloroption=" --color=auto"
  270. else
  271. # export LSCOLORS=gxfxcxdxbxegedabagacad
  272. export LSCOLORS=DxGxcxdxCxegedabagacad
  273. export CLICOLOR=1
  274. fi
  275. alias ls="ls -hCF${_coloroption}${_timeoption}"
  276. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  277. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  278. _timeformat_num="%Y%m%d%H%M%S"
  279. alias datenum="date +$_timeformat_num"
  280. # export GREP_OPTIONS=""
  281. alias gr="grep -n --color=always"
  282. $iswindows && alias gr="grep -n"
  283. alias less="less -F"
  284. __safe_alias em="emacs -nw"
  285. __safe_alias vi=vim
  286. alias pstree="LANG=C pstree"
  287. alias cp="cp -v"
  288. alias mv="mv -v"
  289. alias rm="rm -v"
  290. alias mkdir="mkdir -v"
  291. alias rmdir="rmdir -v"
  292. alias psaux="ps auxww"
  293. alias q=exit
  294. __safe_alias e3=e3em
  295. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  296. alias po=popd
  297. alias pu=pushd
  298. __safe_alias sudo="sudo " # use aliases through sudo
  299. __safe_alias sudoe="sudoedit"
  300. # __safe_alias halt="sudo halt"
  301. # __safe_alias reboot="sudo reboot"
  302. null type dbus-send && {
  303. alias suspend="dbus-send --system --print-reply \
  304. --dest=org.freedesktop.UPower \
  305. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  306. alias hibernate="dbus-send --system --print-reply \
  307. --dest=org.freedesktop.UPower \
  308. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  309. }
  310. alias rand="echo \$RANDOM"
  311. __safe_alias xunp="file-roller -h"
  312. __safe_alias pc="sudo \paco -D"
  313. alias pycalc="python -i -c 'from math import *' "
  314. __safe_alias py3=python3
  315. __safe_alias py2=python2
  316. __safe_alias ipy=ipython
  317. __safe_alias ipy3=ipython3
  318. __safe_alias ipy2=ipython2
  319. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  320. # SHELL is set to be /bin/zsh
  321. if $inbash
  322. then
  323. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  324. elif $inzsh
  325. then
  326. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  327. else
  328. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  329. fi
  330. # alias mytime="date +%Y%m%d-%H%M%S"
  331. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  332. # some extra utilities
  333. # type trash >/dev/null 2>&1 && alias rm=trash
  334. __safe_alias mpg123="mpg123 -C -v --title"
  335. __safe_alias xm="xmms2"
  336. #export PLAYER="mpg123 -C -v --title"
  337. __safe_alias screen="screen -e^z^z"
  338. #alias zcd="cd \`zenity --file-selection --directory\`"
  339. __safe_alias gtags="gtags --verbose"
  340. __safe_alias htags="htags --xhtml --symbol --line-number \
  341. --frame --alphabet --verbose"
  342. __safe_alias au=aunpack
  343. # __safe_alias lv="lv|less"
  344. __safe_alias rs="rsync --progress --itemize-changes --compress"
  345. __safe_alias vagr=vagrant
  346. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  347. if $iscygwin
  348. then
  349. __my_wget_options=" --no-check-certificate"
  350. __safe_alias wget="wget $__my_wget_options"
  351. fi
  352. if $isdarwin
  353. then
  354. alias updatedb="LC_ALL=C updatedb"
  355. # do not use locate installed by macports
  356. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  357. fi
  358. # somehow not work
  359. # typeset -ga chpwd_functions
  360. # chpwd_functions+=pwd
  361. # chpwd(){
  362. # pwd
  363. # }
  364. cd(){
  365. builtin cd "$@" && pwd
  366. }
  367. root(){
  368. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  369. then
  370. cd "`git rev-parse --show-toplevel`"
  371. else
  372. cd /
  373. fi
  374. }
  375. # pad
  376. alias pad=notepad
  377. __safe_alias pad=gedit
  378. __safe_alias pad=leafpad
  379. $isdarwin && alias pad="open -e"
  380. __find_latest_vimdir(){
  381. vimdir=/usr/share/vim
  382. if test -d "$vimdir"
  383. then
  384. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  385. else
  386. echo ""
  387. fi
  388. }
  389. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  390. do
  391. test -n "$f" || continue
  392. f="$f/macros/less.sh"
  393. test -f $f && alias vl=$f && break
  394. done
  395. __safe_alias pa="pacman --color=always"
  396. __safe_alias pa="pacmatic --color=always"
  397. __safe_alias pa="pacapt"
  398. __safe_alias yt=yaourt
  399. # variable for yaourt
  400. null type pacmatic && export PACMAN="pacmatic"
  401. __safe_alias cower="cower --color=auto"
  402. __my_pacman_update_mirrorlist_with_reflector(){
  403. f=/etc/pacman.d/mirrorlist
  404. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  405. if test -z "$cmd"
  406. then
  407. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  408. fi
  409. echo ">>> $cmd ..." 1>&2
  410. sudo sh -c "$cmd" && cat $f
  411. }
  412. null type reflector && test -d /etc/pacman.d && \
  413. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  414. null type apt-get && {
  415. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  416. apt-get update --yes && apt-get upgrade --yes'"
  417. alias aptin="apt-get install"
  418. alias aptsearch="apt-cache search"
  419. alias aptshow="apt-cache show"
  420. }
  421. null type port && {
  422. alias port="port -v"
  423. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  424. port -v upgrade outdated'"
  425. }
  426. if $iscygwin
  427. then
  428. null type windate || \
  429. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  430. # alias cygsu="cygstart /cygwinsetup.exe"
  431. fi
  432. mkpatch(){
  433. if test $# -eq 0
  434. then
  435. echo "usage: mkpatch <olddir> <newdir>"
  436. elif ! test -d "$1"
  437. then
  438. echo "mkpatch: $1 is not a directory"
  439. elif ! test -d "$2"
  440. then
  441. echo "mkpatch: $2 is not a directory"
  442. else
  443. diff -Naur "$1" "$2"
  444. fi
  445. }
  446. __sdcv_less(){
  447. command sdcv -n "$@" | less --quit-if-one-screen
  448. }
  449. command -v sdcv >/dev/null && alias dict=__sdcv_less
  450. g(){
  451. if test $# -eq 0 && null type git-info
  452. then
  453. git info
  454. else
  455. git -c color.ui=always "$@"
  456. fi
  457. }
  458. if null type _git && $inbash
  459. then
  460. # enable programmable completion for g
  461. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  462. || complete -o default -o nospace -F _git g
  463. fi
  464. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  465. __safe_alias m=gitmemo
  466. alias setup.py3="sudo python3 setup.py install --record files.txt"
  467. randomstr(){
  468. len=$1
  469. test -z "$len" && len=8
  470. uuidgen | tr -d - | cut -c 1-len
  471. }
  472. datestr(){
  473. # datestr YYYYMMDDhhmmss
  474. if test -z "$1" || test "$1" = "-h"
  475. then
  476. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  477. return 1
  478. fi
  479. dfmt="" # actual format for date command
  480. while test -n "$1"
  481. do
  482. fmt="$1"
  483. shift
  484. while test -n "$fmt"
  485. do
  486. case "$fmt" in
  487. YYYY*|yyyy*) # year
  488. dfmt="${dfmt}%Y"
  489. fmt="`echo "$fmt" | cut -c 5-`"
  490. ;;
  491. YY*|yy*) # last two digits of year
  492. dfmt="${dfmt}%y"
  493. fmt="`echo "$fmt" | cut -c 3-`"
  494. ;;
  495. MM*) # month (01..12)
  496. dfmt="${dfmt}%m"
  497. fmt="`echo "$fmt" | cut -c 3-`"
  498. ;;
  499. DD*|dd*) # day of month (01..12)
  500. dfmt="${dfmt}%d"
  501. fmt="`echo "$fmt" | cut -c 3-`"
  502. ;;
  503. HH* | hh*) # hour (00..23)
  504. dfmt="${dfmt}%H"
  505. fmt="`echo "$fmt" | cut -c 3-`"
  506. ;;
  507. mm*) # minute (00..59)
  508. dfmt="${dfmt}%M"
  509. fmt="`echo "$fmt" | cut -c 3-`"
  510. ;;
  511. SS*|ss*) # second (00..60)
  512. dfmt="${dfmt}%S"
  513. fmt="`echo "$fmt" | cut -c 3-`"
  514. ;;
  515. *)
  516. char=`echo "$fmt" | cut -c 1`
  517. dfmt="${dfmt}${char}"
  518. fmt="`echo "$fmt" | cut -c 2-`"
  519. ;;
  520. esac
  521. done
  522. done
  523. date +"$dfmt"
  524. }
  525. # ssh(){
  526. # # __my_terminal_title ssh
  527. # command ssh "$@"
  528. # }
  529. __ssh_with_cd(){
  530. # __ssh_with_cd <host> <directory> [<arg> ...]
  531. if test -z "$2"
  532. then
  533. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  534. return 1
  535. fi
  536. host="$1"
  537. shift
  538. dir="$1"
  539. shift
  540. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  541. }
  542. memo(){
  543. if test -z "$1"
  544. then
  545. _memo="memo.txt"
  546. else
  547. _memo="$1/memo.txt"
  548. fi
  549. $EDITOR "$_memo"
  550. if test -z "`cat "$_memo"`"
  551. then
  552. echo "$_memo is empty. Removing."
  553. rm "$_memo"
  554. fi
  555. }
  556. now(){
  557. ___tformat="%Y/%m/%d %H:%M:%S %z"
  558. cal
  559. REPLY=
  560. printf "\\r`date "+${___tformat}"`"
  561. read -t 1
  562. while test $? -ne 0
  563. do
  564. printf "\\r`date "+${___tformat}"`"
  565. read -t 1
  566. done
  567. }
  568. s(){
  569. if git rev-parse --git-dir >/dev/null 2>&1
  570. then
  571. echo ">> git grep -n $@" 1>&2
  572. git grep -n "$@"
  573. elif which ag >/dev/null 2>&1
  574. then
  575. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  576. ag --pager="$PAGER" "$@"
  577. elif which ack >/dev/null 2>&1
  578. then
  579. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  580. ack --pager="$PAGER" "$@"
  581. else
  582. echo \
  583. ">> find . " \
  584. "-path '*/.git' -prune -o" \
  585. "-path '*/.svn' -prune -o" \
  586. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  587. if test $# -eq 0
  588. then
  589. echo "No search word given." 1>&2
  590. return 1
  591. fi
  592. find . \
  593. -path '*/.git' -prune -o \
  594. -path '*/.svn' -prune -o \
  595. -type -f -exec grep -nH -e --color=always "$@" {} + \
  596. | $PAGER
  597. fi
  598. }
  599. MYMANPATH='/usr/lib/erlang/man'
  600. if $inbash || $inzsh
  601. then
  602. man(){
  603. env \
  604. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  605. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  606. LESS_TERMCAP_me=$(printf "\e[0m") \
  607. LESS_TERMCAP_se=$(printf "\e[0m") \
  608. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  609. LESS_TERMCAP_ue=$(printf "\e[0m") \
  610. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  611. MANPATH="`manpath`:$MYMANPATH" \
  612. man "$@"
  613. }
  614. fi
  615. netwait(){
  616. while ! ping -c 1 -t 1 example.com
  617. do
  618. true
  619. done
  620. echo network works.
  621. }
  622. __realpath(){
  623. if type realpath >/dev/null 2>&1
  624. then
  625. command realpath "$@"
  626. else
  627. while ! test -d $1
  628. do
  629. shift
  630. done
  631. (command cd "$d" && echo "$PWD")
  632. # local d="$OLDPWD"
  633. # command cd "$1"
  634. # echo "$PWD"
  635. # command cd "$d"
  636. fi
  637. }
  638. __safe_alias tmux='env -u SHLVL tmux'
  639. tx(){
  640. tmux start-server
  641. if test -z "$1"
  642. then
  643. echo "usage: tx <session_name>"
  644. tmux list-sessions
  645. elif test -z "$TMUX"
  646. then
  647. # -A: attach if already exists
  648. # tmux new-session -A -c "$HOME" -s "$1"
  649. tmux new-session -A -s "$1"
  650. else
  651. # create new session if not exists yet
  652. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  653. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  654. tmux switch-client -t "$1"
  655. fi
  656. }
  657. dt(){
  658. # dt [-h] [<name>] [<command ...>]
  659. __dtach_dir="${TMP}/dtach"
  660. mkdir -p "${__dtach_dir}"
  661. if test -n "${__MY_DTACH}"
  662. then
  663. # if already in dtach session print current session
  664. soc_name="`basename "$__MY_DTACH"`"
  665. echo "Current session: ${soc_name}"
  666. fi
  667. if test -z "$1"
  668. then
  669. # if no arg given show list of sessions
  670. echo "Sessions:"
  671. ls "${__dtach_dir}"
  672. return 0
  673. elif test "$1" = "-h"
  674. then
  675. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  676. return 1
  677. fi
  678. # set socket name
  679. soc_name="${__dtach_dir}/$1"
  680. shift
  681. if test -n "$__MY_DTACH"
  682. then
  683. echo "dtach session cannot be nested." 1>&2
  684. return 1
  685. elif test -S "$soc_name"
  686. then
  687. dtach -a "$soc_name" -e ^^
  688. elif test -e "$soc_name"
  689. then
  690. echo "dt: File named $soc_name already exists."
  691. return 1
  692. elif test -z "$1"
  693. then
  694. # if no command given invoke current shell
  695. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  696. # echo "dt: Socket named $soc_name not exists and no command specified."
  697. # return 1
  698. else
  699. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  700. fi
  701. }
  702. scr(){
  703. test -n "$1" && pf="${1}-"
  704. ___tformat="%Y%m%d-%H%M%S%z"
  705. ___file="${HOME}/${pf}`date +${___tformat}`.script"
  706. __MY_SCRIPT=${___file} script ${___file} "$@"
  707. }
  708. dtscr(){
  709. # dtscr <command ...>
  710. if test -z "$1"
  711. then
  712. echo "dtscr: usage: dtscr <command ...>"
  713. return 1
  714. fi
  715. ___cmdstr="`echo $@ | tr ' ' +`"
  716. ___tformat="%Y%m%d-%H%M%S%z"
  717. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  718. ___scr_file="${HOME}/${___name}.script"
  719. ___dt_dir="${TMP}/dtscr"
  720. mkdir -p "$___dt_dir"
  721. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  722. # echo $_name
  723. # echo $_file
  724. }
  725. mcrypt_stream(){
  726. test $# -eq 2 || return 1
  727. case $1 in
  728. en)
  729. mcrypt --key $2 | base64 ;;
  730. de)
  731. base64 -d | mcrypt -d --key $2 ;;
  732. esac
  733. }
  734. gpg_stream(){
  735. test $# -eq 2 || return 1
  736. case $1 in
  737. en)
  738. gpg --passphrase $2 -c --batch |base64 ;;
  739. de)
  740. base64 -d|gpg --passphrase $2 -d --batch ;;
  741. esac
  742. }
  743. dgpg(){
  744. if test "$1" = help || test -z "$2"
  745. then
  746. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  747. return
  748. fi
  749. ___srcs="$2"
  750. ___dsts="$3"
  751. test -z "$___dsts" && ___dsts="${___srcs}.out"
  752. ___pw=
  753. echo -n "dgpg pw: "
  754. read -s ___pw
  755. echo ""
  756. test -z "$___pw" && return 1
  757. for f in *${___srcs}
  758. do
  759. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  760. echo -n "Processing $f to $___d..."
  761. if test -d "$f"
  762. then
  763. echo "`printf 'failed (%s is directory)' $f`"
  764. elif test -f "$___d"
  765. then
  766. echo "`printf 'failed (%s is already exists)' $___d`"
  767. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  768. then
  769. echo "done"
  770. else
  771. echo "failed"
  772. test -f "$___d" && rm "$___d"
  773. fi
  774. done
  775. }
  776. alias enst="gpg_stream en"
  777. alias dest="gpg_stream de"
  778. showinfo(){
  779. echo "Japanese letters are 表示可能"
  780. __safe_run diskinfo
  781. ! $isdarwin && test -n "${DISPLAY}" && {
  782. __safe_run xrandr | \grep --color=never ^Screen
  783. }
  784. $iswindows || __safe_run finger $USER
  785. LANG=C __safe_runc id
  786. __safe_run xset q
  787. }
  788. x(){
  789. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  790. #mkdir -p ~/.var/log
  791. # nohup startx >~/.var/log/xorg.log 2>&1 &
  792. # exit
  793. exec startx
  794. else
  795. echo "X cant be started! Another X is already running?" 1>&2
  796. fi
  797. }
  798. bak(){
  799. for file in "$@"
  800. do
  801. cp -v ${file} ${file}.bak
  802. done
  803. }
  804. di(){
  805. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  806. then
  807. ___diffcmd=colordiff
  808. else
  809. ___diffcmd=diff
  810. fi
  811. ${___diffcmd} -u "$@" | ${PAGER}
  812. }
  813. tb(){
  814. __datenum=`date +%Y%m%d-%H%M%S`
  815. __tb="$HOME/.var/tb/$__datenum"
  816. mkdir -p "$__tb"
  817. mv "$@" "$__tb"
  818. }
  819. mkdd(){
  820. _d=`date +%Y%m%d-%H%M%S` && \
  821. mkdir -p "$_d"
  822. }
  823. mkcd(){
  824. if test -z "$1"
  825. then
  826. echo "mkcd: usage: mkcd <dir>"
  827. return 1
  828. elif test -d "$1"
  829. then
  830. echo "Dir \"$1\" already exists."
  831. else
  832. mkdir -p "$1"
  833. echo "Dir \"$1\" created."
  834. fi
  835. cd "$1"
  836. }
  837. mkcdd(){
  838. # make and change date directory
  839. _d=`date +%Y%m%d-%H%M%S` && \
  840. mkcd "$_d"
  841. }
  842. if test -n "$TMUX" && null type reattach-to-user-namespace
  843. then
  844. alias pbpaste="reattach-to-user-namespace pbpaste"
  845. alias pbcopy="reattach-to-user-namespace pbcopy"
  846. fi
  847. catclip(){
  848. if $iswindows
  849. then
  850. cat /dev/clipboard | tr -d \\r
  851. elif $isdarwin
  852. then
  853. pbpaste
  854. else
  855. xclip -o -selection "clipboard"
  856. fi
  857. }
  858. setclip(){
  859. if test $# -eq 0
  860. then
  861. exec 3<&0
  862. else
  863. exec 3<<__EOF__
  864. `cat "$@"`
  865. __EOF__
  866. fi
  867. if $iswindows
  868. then
  869. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  870. elif $isdarwin
  871. then
  872. pbcopy 0<&3
  873. else
  874. 0<&3 xclip -i -f -selection "primary" | \
  875. xclip -i -f -selection "clipboard"
  876. fi
  877. exec 3<&-
  878. }
  879. open_file(){
  880. if $iscygwin
  881. then
  882. cygstart "$@"
  883. elif $ismsys
  884. then
  885. cmd.exe //c start "" "$@"
  886. elif $isdarwin
  887. then
  888. touch "$@"
  889. open "$@"
  890. elif $islinux
  891. then
  892. touch "$@"
  893. if null type pcmanfm; then
  894. LC_MESSAGES= pcmanfm "$@"
  895. else
  896. LC_MESSAGES= xdg-open "$@" &
  897. fi
  898. else
  899. cat "$@"
  900. fi
  901. }
  902. o(){
  903. if test $# -eq 0
  904. then
  905. open_file .
  906. else
  907. for f in "$@"
  908. do
  909. open_file "$(realpath "$f")"
  910. done
  911. fi
  912. }
  913. convmv_sjis2utf8_test(){
  914. convmv -r -f sjis -t utf8 *
  915. }
  916. convmv_sjis2utf8_notest(){
  917. convmv -r -f sjis -t utf8 * --notest
  918. }
  919. #################################################
  920. ## pastebin services
  921. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  922. sprunge(){
  923. # http://sprunge.us
  924. if test -z "$1"
  925. then
  926. curl -F 'sprunge=<-' http://sprunge.us
  927. else
  928. curl http://sprunge.us/$1
  929. fi
  930. }
  931. dpaste(){
  932. # http://dpaste.de
  933. if test -z "$1"
  934. then
  935. curl -F 'content=<-' https://dpaste.de/api/
  936. echo
  937. else
  938. curl https://dpaste.de/$1/raw/
  939. fi
  940. }
  941. ######################################
  942. ## Prompt Settings
  943. __my_moc_state(){
  944. type mocp >/dev/null 2>&1 || return
  945. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  946. printf "$1" "`mocp -Q %title 2>/dev/null`"
  947. }
  948. __my_parse_svn_branch() {
  949. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  950. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  951. sed -ne 's#^Repository Root: ##p')
  952. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  953. awk '{print $1}'
  954. }
  955. __my_svn_ps1(){
  956. if svn status >/dev/null 2>&1
  957. then
  958. ___svn_branch=$(__my_parse_svn_branch)
  959. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  960. fi
  961. }
  962. __my_battery_status(){
  963. ___dir=/sys/class/power_supply/BAT0
  964. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  965. test -r $___dir/charge_now
  966. then
  967. ___st=$(cat $___dir/status)
  968. ___full=$(cat $___dir/charge_full)
  969. ___now=$(cat $___dir/charge_now)
  970. ___rate=$(expr $now \* 100 / $full)
  971. printf "$1" "${___st}:${___rate}%"
  972. fi
  973. }
  974. alias bat='__my_battery_status %s\\n'
  975. __my_ps1_scale(){
  976. if null type stty && ! $ismsys
  977. then
  978. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  979. fi
  980. }
  981. __my_ps1_tmux(){
  982. null type tmux || return $last
  983. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  984. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  985. }
  986. __my_ps1_moc(){
  987. __my_moc_state "[MOC:%s]"
  988. }
  989. for f in /usr/share/git/git-prompt.sh \
  990. /usr/share/git-core/contrib/completion/git-prompt.sh \
  991. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  992. /etc/bash_completion.d/git-prompt \
  993. /opt/local/share/git-core/git-prompt.sh \
  994. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  995. do
  996. test -r "$f" && ($inbash || $inzsh) && . "$f" && break
  997. done
  998. GIT_PS1_SHOWDIRTYSTATE=t
  999. GIT_PS1_SHOWUPSTREAM=t
  1000. __my_ps1_git(){
  1001. null type __git_ps1 || return $last
  1002. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  1003. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  1004. }
  1005. __printf_ipaddr(){
  1006. # ipaddress <fmt>
  1007. type ip >/dev/null 2>&1 || return 1
  1008. ___ip=$(LANG=C ip addr show scope global | \
  1009. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  1010. test -n "$___ip" && printf "$1" $___ip
  1011. }
  1012. alias addr="__printf_ipaddr '%s
  1013. '"
  1014. __my_ps1_ipaddr(){
  1015. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  1016. }
  1017. __my_ps1_bttry(){
  1018. ___bst="${TMP}/batterystatus"
  1019. if test -z "$DISPLAY" && ! $iswindows
  1020. then
  1021. test -f $___bst && ___bstr="$(cat $___bst)"
  1022. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  1023. echo "[Battery:$___bstr]"
  1024. __my_battery_status %s >$___bst &
  1025. fi
  1026. }
  1027. __my_ps1_memo(){
  1028. test -f memo.txt && echo "m:`du -b memo.txt|cut -f 1`"
  1029. }
  1030. __my_ps1_dirs(){
  1031. dirs | wc -l
  1032. }
  1033. __my_ps1_jobs(){
  1034. # __my_ps1_jobs [<num>]
  1035. if test -n "$1"
  1036. then
  1037. jobs="$1"
  1038. else
  1039. jobs="`jobs | wc -l`"
  1040. fi
  1041. if test "$jobs" -gt 0
  1042. then
  1043. echo "JOBS:$jobs"
  1044. fi
  1045. }
  1046. __my_ps1_dollar(){
  1047. if test -z "$SHLVL"
  1048. then
  1049. printf "$1"
  1050. else
  1051. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  1052. fi
  1053. }
  1054. __my_alert_fail(){
  1055. test $laststatus -eq 0 || \
  1056. echo "STATUS:${laststatus}"
  1057. }
  1058. # About ansi escape sequences
  1059. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  1060. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  1061. if $inbash || $inzsh
  1062. then
  1063. if $inzsh
  1064. then
  1065. __attr_beg=$'%{\033['
  1066. __attr_end='m%}'
  1067. else
  1068. __attr_beg='\[\033['
  1069. __attr_end='m\]'
  1070. fi
  1071. __color_default="${__attr_beg}0${__attr_end}"
  1072. __color_black="${__attr_beg}0;30${__attr_end}"
  1073. __color_red="${__attr_beg}0;31${__attr_end}"
  1074. __color_green="${__attr_beg}0;32${__attr_end}"
  1075. __color_brown="${__attr_beg}0;33${__attr_end}"
  1076. __color_blue="${__attr_beg}0;34${__attr_end}"
  1077. __color_purple="${__attr_beg}0;35${__attr_end}"
  1078. __color_cyan="${__attr_beg}0;36${__attr_end}"
  1079. __color_light_gray="${__attr_beg}0;37${__attr_end}"
  1080. __color_dark_gray="${__attr_beg}1;30${__attr_end}"
  1081. __color_light_red="${__attr_beg}1;31${__attr_end}"
  1082. __color_light_green="${__attr_beg}1;32${__attr_end}"
  1083. __color_yellow="${__attr_beg}1;33${__attr_end}"
  1084. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1085. __color_light_purple="${__attr_beg}1;35${__attr_end}"
  1086. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1087. __color_white="${__attr_beg}1;37${__attr_end}"
  1088. __color_bg_black="${__attr_beg}40${__attr_end}"
  1089. __color_bg_red="${__attr_beg}41${__attr_end}"
  1090. __color_bg_green="${__attr_beg}42${__attr_end}"
  1091. __color_bg_brown="${__attr_beg}43${__attr_end}"
  1092. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1093. __color_bg_purple="${__attr_beg}45${__attr_end}"
  1094. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1095. __color_bg_light_gray="${__attr_beg}47${__attr_end}"
  1096. __attr_underline="${__attr_beg}4${__attr_end}"
  1097. __attr_reverse="${__attr_beg}7${__attr_end}"
  1098. __attr_bold="${__attr_beg}1${__attr_end}"
  1099. fi
  1100. # NOTE: tput is another easy way to set colors and background
  1101. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1102. # color blue.
  1103. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1104. if test "$TERM" != dumb
  1105. then
  1106. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1107. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1108. # color for ::
  1109. case "`hostname`" in
  1110. arch-aspireone)
  1111. __my_c4="$__color_yellow"
  1112. ;;
  1113. arch-mba)
  1114. __my_c4="$__color_light_cyan"
  1115. ;;
  1116. newkiwi)
  1117. __my_c4="$__color_light_purple"
  1118. ;;
  1119. debian-vb-win7-opti)
  1120. __my_c4="$__color_light_red"
  1121. ;;
  1122. *)
  1123. __my_c4="$__color_light_green"
  1124. ;;
  1125. esac
  1126. __my_c5="$__color_black$__color_bg_light_gray" # color for SCR
  1127. __my_cdef="$__color_default"
  1128. fi
  1129. if $inbash
  1130. then
  1131. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1132. elif $inzsh
  1133. then
  1134. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1135. fi
  1136. __my_ps1_info1(){
  1137. # first line of PS1
  1138. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1139. }
  1140. test -n "$__MY_SCRIPT" && \
  1141. __my_ps1_str_scr="SCR"
  1142. test -n "$SSH_CONNECTION" && \
  1143. __my_ps1_str_ssh="SSH"
  1144. test -n "$__MY_DTACH" && \
  1145. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1146. __my_ps1_info2(){
  1147. # second line of PS1
  1148. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1149. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1150. | sed -e 's/ /|/g'
  1151. }
  1152. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1153. __my_ps1_save_pos="\[\033[s\]"
  1154. __my_ps1_restore_pos="\[\033[u\]"
  1155. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1156. __my_ps1_move_15left="\[\033[15D\]"
  1157. # collapse when command line is too long and try to write over this string
  1158. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1159. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1160. if $inzsh
  1161. then
  1162. PROMPT="\
  1163. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1164. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1165. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1166. elif $inbash
  1167. then
  1168. PS1="\
  1169. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1170. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1171. else
  1172. true
  1173. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1174. fi
  1175. ###################################
  1176. # set header and titles
  1177. __my_set_header_line(){
  1178. # save current position
  1179. printf "\033[s"
  1180. # move to 0,0
  1181. printf "\033[0;0H"
  1182. # clear curent to eol
  1183. printf "\033[K"
  1184. # inverse color
  1185. printf "\033[7m"
  1186. printf "$1"
  1187. # restore color
  1188. printf "\033[0m"
  1189. # restore saved position
  1190. printf "\033[u"
  1191. }
  1192. __my_set_screen_name(){
  1193. # set window name
  1194. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1195. then
  1196. echo -ne "\033k$1\033\\"
  1197. fi
  1198. }
  1199. __my_set_title(){
  1200. case $TERM in
  1201. (rxvt*|xterm*|aterm|screen*)
  1202. test -t 1 &&
  1203. test -z "$EMACS" &&
  1204. echo -n -e "\033]0;$1\007"
  1205. ;;
  1206. esac
  1207. }
  1208. if test -n "$TMUX"
  1209. then
  1210. # running tmux locally
  1211. __terminal_title="\$(basename \${PWD})"
  1212. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1213. then
  1214. # ssh connect from tmux terminal
  1215. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1216. else
  1217. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1218. fi
  1219. if $inzsh
  1220. then
  1221. precmd(){
  1222. laststatus=$?
  1223. eval __my_set_title ${__terminal_title}
  1224. }
  1225. else
  1226. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";$PROMPT_COMMAND"
  1227. fi
  1228. laststatus=0